unit hiOneWire;

interface

uses Kol,Share,Windows,Debug;




type
	THIONEWIRE = class(TDebug)
	
	OverWrite: TOverlapped; //    
	OverRead: TOverlapped; //    
	OldDCB:TDCB;// Old         
	Oldcto:_COMMTIMEOUTS;
	DCB:TDCB;//_COMMTIMEOUTS  TDCB     windows.pas	
	cto :_COMMTIMEOUTS;  

  private
	// //////
	FTimer:PTimer;// 
	
	///////////////
	hCom: THandle;
	ComNo:integer;
	FlgErr:boolean; //       boolean   
	CRC:byte;//    CRC
	ROM:string[16]; //ROM  
	TEMPER:string;
	
	ArrRom: array [0..63] of byte;//    ROM , 64 (  )
//  
	procedure CloseCom();//   ComNo
	procedure OpenCom(No:integer);//   i:=ToIntegerEvent(_data_Port);//  
	procedure SetCom(BaudRate:integer);//  , 
	function IntToBin(Value, Digits: Integer):string;//    
	//   OneWare
	function Reset():byte;// RESET     PRESENCE
	function BitRW(send:byte):byte;//   
	function ByteRW(send:byte):byte;//   
	procedure ErrorOut(FunName:string);//   WinApi     GetLastError FunName=    AddressErr=  
	procedure CheckCRC(b : Byte);//    CRC
	procedure OnTimer(Obj:PObj);
	procedure TempDS18B20RAM();//     1 
	procedure SearhROM(instruction:byte);
	procedure WriteData(Send:string);//      HEX

  public
	
	_prop_BaudRate:integer;
	_prop_Parity:integer;
	_prop_TimeOut:integer;
	_event_onWrite:THI_Event;
	_event_onComOffOn:THI_Event;//   1- 0-
	_event_onROM:THI_Event;//   
	_event_onAlarmROM:THI_Event;//    
	_event_onRead:THI_Event;
	_event_onErrOut:THI_Event;       //       WinApi
	_event_onPresence:THI_Event;//   RESET  
	_event_onTemper:THI_Event;
	_data_BaudRate:THI_Event;
	_data_Port:THI_Event;
	_data_DeviceROM:THI_Event;
	_data_UserTH:THI_Event;
	_data_UserTL:THI_Event;
	_data_ConfigReg:THI_Event;
	
	
    constructor Create;
    destructor Destroy; override;
    
procedure _work_doTempDS18B20(var _Data:TData; Index:word);// 
procedure _work_doReset(var _Data:TData; Index:word);//  RESET     PRESENCE
procedure _work_doSearchDevice(var _Data:TData; Index:word);
procedure _work_doClose(var _Data:TData; Index:word);
procedure _work_doOpen(var _Data:TData; Index:word);
procedure _work_doSearchAlarm(var _Data:TData; Index:word);
procedure _work_doWrite(var _Data:TData; Index:word);
procedure _work_doRead(var _Data:TData; Index:word);
procedure _work_doWriteEEPROM(var _Data:TData; Index:word);
procedure _var_Temper(var _Data:TData; Index:word);
 
 end;

implementation

constructor THIONEWIRE.Create;
begin
  inherited;//    ,    .    ,  . 
 hCom := INVALID_HANDLE_VALUE; 
 ComNo:=0; 
 FTimer := NewTimer(1000);
 FTimer.Enabled := false;
 FTimer.OnTimer := onTimer;
 CloseCom;
end;

destructor THIONEWIRE.Destroy;
begin
  CloseCom; 
 ZeroMemory(@DCB, SizeOf(DCB)); 
 {$ifndef F_P}
   FTimer.Free;
{$endif} 
 
  inherited; 
end;
/////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////


procedure THIONEWIRE.OnTimer;///     
begin
FTimer.Enabled := false;//   
TempDS18B20RAM();
end;
//====================================================================

//===  
procedure THIONEWIRE._work_doSearchAlarm;
begin
SearhROM($EC);//   
end;

procedure THIONEWIRE._work_doSearchDevice;
begin
SearhROM($F0);//   
end;
//===   ==============================================================
procedure THIONEWIRE.SearhROM(instruction:byte);
var
	akk:byte;// 
	CountDevice:byte;//  -  
	CountROMbit:byte;//    ROM = 64
	MasterBit:byte;// ()  ROM,    2-  (10  01)    
	SlaveBit:byte;//  ()  ROM
	SetByte:byte;//    MasterBit SlaveBit   
	s:string[16];//   ROM
	FirstColl:byte;//         
	b,b1,b2,b3,b4,b5,b6:Byte;// 
begin
FillChar(ArrRom, SizeOf(ArrRom), 0);//    ROM
FirstColl:=0;
	for CountDevice := 0 to 255 do// - 
		begin		
		CRC:=0;
		if Reset() = 1 then begin
					SetCom (115200);//   
					//if FlgErr = 1 then ShowMessage('exit');//      
					b:= ByteRW(instruction);//    ROM  
			for CountROMbit := 0 to 63 do//     ROM
					begin
					SetByte:=0;
					//    
					MasterBit:=BitRW($FF);// ()   ROM
					//      ,  MasterBit=1  SetByte=00000001
					if MasterBit = $FF then SetByte:= SetByte or (1 shl 0) //  
									else SetByte:= SetByte and not (1 shl 0); //  
					//    
					SlaveBit:=BitRW($FF);//    ROM									0			1		2		3
					//   2   SetBit,  4   SetBit (00000000,00000001,00000010,00000011)
					if SlaveBit = $FF then SetByte:= SetByte or (1 shl 1) //  
									else SetByte:= SetByte and not (1 shl 1); //  
					//   2-    
					if SetByte = $03	then Break;   //00000011    ,   ,   
					if SetByte = $01	then begin//  SetBit=00000001     ROM=1
									ArrRom[CountROMbit]:= ArrRom[CountROMbit] or (1 shl 0) ;// 1      
									b:=BitRW($FF);//   1(  ,   )
									end;
					if SetByte =$02	then begin// 00000010   ,  ROM=0
									ArrRom[CountROMbit]:= ArrRom[CountROMbit] and not (1 shl 0);// 0     ROM  
									b:=BitRW($00);//   0(  ,   )
									end;
					if SetByte = $00	then begin//    00, 
										//       (  )
										if ((ArrRom[CountROMbit] shr 7) and 1) =0 then akk:=$00;// 7   (1,0  ), 0  = ROM
										if ((ArrRom[CountROMbit] shr 7) and 1) =1 then akk:=$FF;
										for  b1:= 63 downto  CountROMbit+1 do 
													begin 
													//      ,  (+1)
													if ((ArrRom[b1] shr 7) and 1)=1 then break; end;
					if (akk = $00) and (CountROMbit = b1) then begin//  0         (  )    
									if (CountDevice<>0) and (FirstColl=CountROMbit) then break;//     
									if FirstColl = 0 then FirstColl:=CountROMbit;//    
									b:=BitRW($FF);//    := $FF;
									ArrRom[CountROMbit]:= ArrRom[CountROMbit] or (1 shl 0) ;//1=1
									ArrRom[CountROMbit]:= ArrRom[CountROMbit] or (1 shl 7) ;//1  					
														end;
					if (akk = $00) and (CountROMbit < b1) then begin// 
									b:=BitRW($00);//:= $00;
									ArrRom[CountROMbit]:= ArrRom[CountROMbit] and not (1 shl 0);// 0//1=1,2=0
									ArrRom[CountROMbit]:= ArrRom[CountROMbit] and not (1 shl 7);// 0 	
														end;
					if (akk = $FF) and (CountROMbit < b1) then begin
									b:=BitRW($FF);//:= $FF;
									ArrRom[CountROMbit]:= ArrRom[CountROMbit] or (1 shl 0) ;////1=1
									ArrRom[CountROMbit]:= ArrRom[CountROMbit] or (1 shl 7) ;//1  				
														end;
					if (akk = $FF) and (CountROMbit = b1) then begin//   
									b:= BitRW($00);//:= $00;
									ArrRom[CountROMbit]:= ArrRom[CountROMbit] and not (1 shl 0);// 0//2=0
									ArrRom[CountROMbit]:= ArrRom[CountROMbit] and not (1 shl 7);// 0 					
														end;
									end;//
		
			end;//////////////////
		if (CountDevice > 0) and  (FirstColl = 0) then break; //          
		if  CountROMbit <63 then break;//       ROM   , 11  
		s:='';
		for b5 := 0 to 7 do  //   8  
		begin 
         			for b4 := 0 to 7 do  //      
			begin 
			b3:=ArrRom[b4+(b5*8)];//   1 
			if ((b3 shr 0) and 1)=0 then b6 := b6 and not (1 shl b4); //  
			if ((b3 shr 0) and 1)=1  then b6 := b6 or (1 shl b4); //  
			ArrRom[b4+(b5*8)]:= ArrRom[b4+(b5*8)] and not (1 shl 0);// 
			end;
		CheckCRC(b6);//        CRC
		s:=Int2Hex(b6,2)+s;//  
		end;
		 if CRC=0 then begin
						if instruction = $EC then  _hi_OnEvent(_event_onAlarmROM,s); //  ROM   
						if instruction = $F0  then _hi_OnEvent(_event_onROM,s); //  ROM    	
					end	else break;//   23   (CRC)  		
					end else exit;// RESET   
		
		
		end;// for CountDevice
end;

procedure THIONEWIRE._work_doWriteEEPROM;
var i:integer;
b,TH,TL,Config:byte;
begin

TH:=ToIntegerEvent(_data_UserTH);
TL:=ToIntegerEvent(_data_UserTL);
Config:=ToIntegerEvent(_data_ConfigReg);
ROM:=ReadString(_Data,_data_DeviceROM);//  ROM     
//ShowMessage('TH = '+Int2Str(integer (TH)));
if Reset() = 1 then begin
				SetCom (115200);//   
				_hi_OnEvent(_event_onWrite,'RESET');
				b:= ByteRW($55);// MATCH ROM [55h] ROM 64bit
				_hi_OnEvent(_event_onWrite,Int2Hex(b,2));
				WriteData(ROM);//  ROM
				 _hi_OnEvent(_event_onWrite,'ROM');
				 b:= ByteRW($4E);//     3- 
				_hi_OnEvent(_event_onWrite,Int2Hex(b,2));
				//  3 
				b:=ByteRW(TH);
				_hi_OnEvent(_event_onWrite,Int2Hex(b,2));
				b:=ByteRW(TL);
				_hi_OnEvent(_event_onWrite,Int2Hex(b,2));
				b:=ByteRW(Config);
				_hi_OnEvent(_event_onWrite,Int2Hex(b,2));
				end;
if Reset() = 1 then begin
				SetCom (115200);//   
				_hi_OnEvent(_event_onWrite,'RESET');
				b:= ByteRW($55);// MATCH ROM [55h] ROM 64bit
				_hi_OnEvent(_event_onWrite,Int2Hex(b,2));
				WriteData(ROM);//  ROM
				 _hi_OnEvent(_event_onWrite,'ROM');
				 b:= ByteRW($48);//     3- 
				_hi_OnEvent(_event_onWrite,Int2Hex(b,2));
				end;				
end;
//===    ================================================
procedure THIONEWIRE._work_doTempDS18B20;
var b:byte;
begin
ROM:=ReadString(_Data,_data_DeviceROM);//  ROM     
if Reset() = 1 then begin
				 SetCom (115200);//   
				 _hi_OnEvent(_event_onWrite,'RESET');
				 b:= ByteRW($55);// MATCH ROM [55h] ROM 64bit
				 _hi_OnEvent(_event_onWrite,Int2Hex(b,2));
				 WriteData(ROM);//  ROM
				b:= ByteRW($44);//   
				_hi_OnEvent(_event_onWrite,Int2Hex(b,2));
				FTimer.Enabled := true;//    1 
				 _hi_OnEvent(_event_onWrite,' 1 .');
				 end;
end;
//===    ===========================================				 
procedure THIONEWIRE.TempDS18B20RAM;//  9 				 
var b,LSB,MSB,UserTH,UserTL,Config,Res5,Res6,Res7,CRC:byte;
znak:string[1];
w:WORD;
begin
if Reset() = 1 then begin
				SetCom (115200);//   
				_hi_OnEvent(_event_onWrite,'RESET');
				b:= ByteRW($55);// MATCH ROM [55h] ROM 64bit
				_hi_OnEvent(_event_onWrite,Int2Hex(b,2));
				WriteData(ROM);//  ROM
				  b:= ByteRW($BE);//    9 
				_hi_OnEvent(_event_onWrite,Int2Hex(b,2));
				//  
				LSB:=ByteRW($FF);
				_hi_OnEvent(_event_onRead,Int2Hex(LSB,2));
				MSB:=ByteRW($FF);
				_hi_OnEvent(_event_onRead,Int2Hex(MSB,2));
				UserTH:=ByteRW($FF);
				_hi_OnEvent(_event_onRead,Int2Hex(UserTH,2));
				UserTL:=ByteRW($FF);
				_hi_OnEvent(_event_onRead,Int2Hex(UserTL,2));
				Config:=ByteRW($FF);
				_hi_OnEvent(_event_onRead,Int2Hex(Config,2));
				Res5:=ByteRW($FF);
				_hi_OnEvent(_event_onRead,Int2Hex(Res5,2));
				Res6:=ByteRW($FF);
				_hi_OnEvent(_event_onRead,Int2Hex(Res6,2));
				Res7:=ByteRW($FF);
				_hi_OnEvent(_event_onRead,Int2Hex(Res7,2));
				CRC:=ByteRW($FF);
				_hi_OnEvent(_event_onRead,Int2Hex(CRC,2));
				end;
znak:='+';				
if MSB >=  $08 then begin //  
			znak:='-';
			w:=($FFFF xor w)+1;
			end;
TEMPER:= znak+Double2str((LSB+ 256 * MSB)/16);
_hi_OnEvent(_event_onTemper, TEMPER);
end;
//===    ===================================================
procedure THIONEWIRE._var_Temper;//    DS18B20
begin
dtString(_Data,TEMPER)
end;
//===    CRC ==============================================
procedure THIONEWIRE.CheckCRC(b : Byte);// c 
 var  i : integer;
 begin
	for i := 1 to 8 do
	begin
	if ((b xor CRC) and 1) > 0 then CRC := ((CRC xor $18) shr 1) or $80
	else CRC := CRC shr 1;
	b := b shr 1;
	end;
end;
//==== RESET  PRESENCE ==================================================
procedure THIONEWIRE._work_doReset;// true  
begin
 _hi_OnEvent(_event_onPresence,Reset());
end;
//==== RSET =======================================================================
function THIONEWIRE.Reset():byte;// true  
var b:byte;
begin
Result:=0;
SetCom (9600);//   
if not FlgErr then begin
				b:=BitRW($F0);//  F0,    b
				//ShowMessage('Reset'+Int2Str(integer (b)));
				if (b = $F0) or (b = 0) then begin //    ,    ( ,  )
										Result:=0;
										SetLastError(1167);//    (   1167 ERROR_DEVICE_NOT_CONNECTED   
										ErrorOut('RESET PRESENCE');//     
										end else Result:=1;
				end;
end;
//====  ================================================================
procedure THIONEWIRE._work_doRead;
var w:Word;i:integer;b:byte; 
begin
SetCom (115200);//   
w := ReadInteger(_Data,Null);//      
	for i := 1 to w do  //       
	begin
	b:=ByteRW($FF);
	_hi_OnEvent(_event_onRead,Int2Hex(b,2));
	end;
end;

procedure THIONEWIRE._work_doWrite;
var s:string;
begin
s:= ReadString(_Data,Null);//     
if (3 = Length(s)) and (s ='ROM') then  WriteData(ReadString(_Data,_data_DeviceROM))
else WriteData(s);
end;
//====     HEX  ========================================
procedure THIONEWIRE.WriteData(Send:string);
var L,i:integer;	b:byte;	s:string;//     
begin
SetCom (115200);//   
L:=Length(Send);//   , - 
if ((L shr 0)and 1) =0  then begin//     
					L:= L shr 1;//   2,    
					//ShowMessage('  '+Int2Str(integer (L)));
					for i:=L  downto 1 do//    
					begin
					
					if (Send[i*2-1] in  ['0'..'9','A'..'F']) and  (Send[i*2] in  ['0'..'9','A'..'F']) then begin//   
					b:= ByteRW(Hex2Int(copy(Send,(i*2-1),2)));// 1 byte
					_hi_OnEvent(_event_onWrite,Int2Hex(b,2));//        
					end else begin
					ShowMessage('  ');
					SetLastError(10022);// 10022 WSAEINVAL   
					ErrorOut('doWrite');//     
					end;
					
					end;// 
					end;
end;
//======    =======================================================
function THIONEWIRE.ByteRW(send:byte):byte;//   
var i:integer; b,ByteIn:Byte;
 begin
 FlgErr:=false;
 Result:=0;
 ByteIn:= 0;
 for i := 0 to 7 do  //       
	 begin 
	 if FlgErr then break;
	 if send and (1 shl (i)) <>0 then b:=BitRW($FF)
							else b:=BitRW($00);
	//      
	if b = $FF then ByteIn:= ByteIn or (1 shl i) //  
			else ByteIn:= ByteIn and not (1 shl i); //  
	end;    
 if FlgErr then begin 
				Result:=0;
				SetLastError(29);//    29 (0x001D)      .
				ErrorOut('ByteRW OneWare');//     
				// : 30 (0x001E)      .
				end
				else  Result:=ByteIn;//    ()
 end;
//====     =========================================================
function THIONEWIRE.BitRW(send:byte):byte;//       ,   RESET  / 
var Received,Sended,Signaled, MaskEvent : DWORD;//  
begin
	if not WriteFile(hCom, send, 1, Sended, @OverWrite) then ErrorOut('WriteFile');//
	OverRead.hEvent:= CreateEvent(nil, true, true, nil);//     ,   
	if not SetCommMask(hCom, EV_RXCHAR)then ErrorOut('SetCommMask');//  ,     .     .
	if not WaitCommEvent(hCom, MaskEvent, @OverRead) then ErrorOut('WaitCommEvent');
	Signaled:= WaitForSingleObject(OverRead.hEvent, 1000{INFINITE});
	If (Signaled  = WAIT_OBJECT_0) then begin 
									If GetOverlappedResult(hCom, OverRead, Received, false) then begin
																								If (MaskEvent and EV_RXCHAR) <> 0 then if not ReadFile(hCom, Byte(Result), 1, Received, @OverRead) then ErrorOut('ReadFile');
																								end;
									end 
									else begin //  
									 
									 Result:=0;
									 SetLastError(Signaled);//   
									ErrorOut('WaitForSingleObject');//     
									end;
end;
//=========     ===========================================
procedure THIONEWIRE._work_doOpen;
var i:integer;
begin
i:=ToIntegerEvent(_data_Port);//  
//i:=ReadInteger(_Data,_data_Port); //       
if (i = ComNo) and  (hCom  <> INVALID_HANDLE_VALUE) then Exit;//    
if i =0 then CloseCom(); //            0
if i <> 0 then OpenCom(i);//     i
if FlgErr then _hi_OnEvent(_event_onComOffOn,Int2Str(integer (0)))///
		else _hi_OnEvent(_event_onComOffOn,Int2Str(integer (1)));///
											
end;
//==========   ========================================================
procedure THIONEWIRE.OpenCom(No:integer);
var PortParam,NameCom: string;
begin
FlgErr:=false;
NameCom:= '\\.\Com' + Int2Str(No);//    
hCom := CreateFile(PChar(NameCom), GENERIC_READ or GENERIC_WRITE, 0, nil, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0);//     . ,     hCom=INVALID_HANDLE_VALUE
if hCom = INVALID_HANDLE_VALUE then ErrorOut('CreateFile')//      
								else begin //       
								if not GetCommTimeouts(hCom, Oldcto) then ErrorOut('Old GetCommTimeouts');//  
								FillChar(cto, sizeof(cto), #0);   //   .    ,    
								if not SetCommTimeouts(hCom, cto) then ErrorOut('SetCommTimeouts');//   cto 
								if not GetCommState(hCom, OldDCB) then ErrorOut('Old GetCommState');//        DCB	
								FillChar(DCB, sizeof(DCB), #0);   //
								DCB:=OldDCB;
								if not PurgeComm(hCom, PURGE_RXCLEAR) then ErrorOut('PURGE_RXCLEAR');//   
								if not PurgeComm(hCom, PURGE_TXCLEAR) then ErrorOut('PURGE_TXCLEAR');//   
								ComNo:=No;
								end;
end;
//=========   =========================================================
procedure THIONEWIRE._work_doClose;
begin
  CloseCom;
 _hi_OnEvent(_event_onComOffOn,Int2Str(integer (0)));
  end;
 //==========   ========================================================
 procedure THIONEWIRE.CloseCom;
begin
if hCom  <> INVALID_HANDLE_VALUE then begin //              OldDCB  Oldcto  
									if not SetCommState(hCom, OldDCB)then ErrorOut('Old SetCommState');//  DCB (ErrorOut   )
									if not SetCommTimeouts(hCom, Oldcto) then ErrorOut('Old SetCommTimeouts');//    cto(ErrorOut   )
									if not CloseHandle(hCom) then ErrorOut('CloseHandle');//   ( )
									//ShowMessage(' Old');
									
									end;
hCom := INVALID_HANDLE_VALUE; //  
ComNo:= 0;
FlgErr:= true;

 end;
 //========    ============================================
procedure THIONEWIRE.SetCom (BaudRate:integer);
var PortParam: string; i: boolean;
begin
PortParam := 'baud=' + Int2Str(BaudRate) + ' parity=N data=8 stop=1 xon=off ';//     
if not BuildCommDCB(PChar(PortParam), DCB) then ErrorOut('BuildCommDCB');//  DCB  ()    ,  
if not SetCommState(hCom, DCB)then ErrorOut('SetCommState');//
end;
 //===    WinApi   GetLastError
procedure THIONEWIRE.ErrorOut(FunName:string);
var i:integer;
begin
i:= GetLastError;
if i = 997 then exit;//  997  ,   ,   ,  .
//ShowMessage(SysErrorMessage( i ));
FlgErr:= true;//     
_hi_OnEvent(_event_onErrOut,FunName+';'+Int2Str(i)+';'+ SysErrorMessage(i)); 
end;
//====  IntToBin   =================================================
function THIONEWIRE.IntToBin(Value, Digits: Integer):string;//IntToBin
var i:integer; s:string;// ShowMessage(' = '+IntToBin(value{},8{- }));
begin
s := '';
for i := 0 to Digits-1 do
begin
s := chr(Value and 1 + 48) + s;// 48      
Value := Value shr 1;
end;
result:=s;
end; 
//===================================================================================
//===================================================================================
  
  end. //  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
